
UIPanelWindows["Nurfed_CombatOptionsFrame"] = {area = "center", pushable = 0};

function Nurfed_CombatFramesMenu()
	if (Nurfed_CombatOptionsFrame:IsVisible()) then
		HideUIPanel(Nurfed_CombatOptionsFrame);
	else
		ShowUIPanel(Nurfed_CombatOptionsFrame);
	end
end

function Nurfed_CombatLogOnLoad()
	for k, v in Nurfed_CombatEvents do
		this:RegisterEvent(v);
	end
	
	-- Register our slash command
	SLASH_NURFEDCOMBAT1 = "/nurfedcombat";
	SLASH_NURFEDCOMBAT2 = "/ncombat";
	SlashCmdList["NURFEDCOMBAT"] = function(msg)
		NurfedCombat_SlashCommandHandler(msg);
	end
end

local function Nurfed_CombatLogPrint(msg)
	if (ChatFrame2) then
		ChatFrame2:AddMessage(msg);
	end
end

local function Nurfed_CombatUnit(unit)
	local i;
	if (unit == YOU) then
		return "You";
	end
	if (UnitExists("pet") and unit == UnitName("pet")) then
		return "Pet";
	end
	if (GetNumPartyMembers() > 0) then
		for i = 1, GetNumPartyMembers() do
			if (unit == UnitName("party"..i)) then
				return "Party";
			end
		end
	end
	if (GetNumRaidMembers() > 0) then
		for i = 1, GetNumRaidMembers() do
			if (unit == UnitName("raid"..i)) then
				return "Raid";
			end
		end
	end
	return "Enemy";
end

local function Nurfed_FormatRGB(option, crit)
	local info = {};
	local color = {};
	if (Nurfed_CombatLogConfig and Nurfed_CombatLogConfig[option]) then
		info = Nurfed_CombatLogConfig[option];
		if (crit) then
			local overlay = Nurfed_CombatLogConfig["Overlay"];
			color.r = (info.r/2) + (overlay.r/2);
			color.g = (info.g/2) + (overlay.g/2);
			color.b = (info.b/2) + (overlay.b/2);
		else
			color.r = info.r;
			color.g = info.g;
			color.b = info.b;
		end
		return string.format("%02x%02x%02x", (color.r*255), (color.g*255), (color.b*255));
	end
	return "000000";
end

local function Nurfed_CombatLogDamage(option, unit, target, damage, crit, spell, damagetype, resist)
	local unittype, missed;
	if (unit == YOU) then
		unittype = "You";
	else
		unittype = Nurfed_CombatUnit(unit);
	end
	unit = "[|cff"..Nurfed_FormatRGB(unittype)..unit.."|r]";

	option = unittype.."_"..option;


	if (target) then
		unittype = Nurfed_CombatUnit(target);
		target = "[|cff"..Nurfed_FormatRGB(unittype)..target.."|r]";
		if (string.find(option, "Enemy")) then
			option = option.."_"..unittype;
		end
	end

	if (Nurfed_CombatLogConfig[option] ~= 1) then
		return;
	end

	if (spell) then
		if (damagetype and Nurfed_CombatLogConfig[damagetype]) then
			spell = "|cff"..Nurfed_FormatRGB(damagetype)..spell.."|r";
		else
			spell = "|cff"..Nurfed_FormatRGB("Generic")..spell.."|r";
		end
		if (crit) then
			spell = spell.." Crit";
		end
	else
		if (crit) then
			spell = "Crit";
		else
			spell = "Hit"
		end
	end

	if (damage) then
		if (damagetype and damagetype == "Heal") then
			if (crit) then
				damage = "|cffffff00*|r|cff"..Nurfed_FormatRGB("Heal", true).."+"..damage.."|r|cffffff00*|r";
			else
				damage = "|cff"..Nurfed_FormatRGB("Heal").."+"..damage.."|r";
			end
		else
			if (crit) then
				damage = "|cffffff00*|r|cff"..Nurfed_FormatRGB("Damage", true)..damage.."|r|cffffff00*|r";
			else
				damage = "|cff"..Nurfed_FormatRGB("Damage")..damage.."|r";
			end
		end
	end

	text = unit.." "..spell;
	if (target) then
		text = text.." "..target;
	end
	if (damage) then
		text = text.." "..damage;
	elseif (resist) then
		text = text.." Resist";
	end

	Nurfed_CombatLogPrint(text);
end

local function Nurfed_AuraFormat(option, unit, buff, fade, debuff)
	local text, unittype;
	if (unit == YOU) then
		unittype = "You";
	else
		unittype = Nurfed_CombatUnit(unit);
	end

	option = unittype.."_"..option;
	if (Nurfed_CombatLogConfig[option] ~= 1) then
		return;
	end


	text = "[|cff"..Nurfed_FormatRGB(unittype)..unit.."|r]";
	if (fade) then
		text = text.." |cff"..Nurfed_FormatRGB("Aura")..buff.."|r Fades";
	elseif (debuff) then
		text = text.." Afflicted by |cff"..Nurfed_FormatRGB("Aura")..buff;
	else
		if (unit == YOU) then
			text = text.." Gain |cff"..Nurfed_FormatRGB("Aura")..buff;
		else
			text = text.." Gains |cff"..Nurfed_FormatRGB("Aura")..buff;
		end
	end
	Nurfed_CombatLogPrint(text);
end

local function Nurfed_DeathFormat(option, unit, rank, honor, dishonor, xp, xpbonus1, xpbonus2)
	local text;
	if (unit) then
		if (unit == YOU) then
			text = "--** |cff"..Nurfed_FormatRGB("You")..unit.."|r Die";
		else
			unittype = Nurfed_CombatUnit(unit);
			text = "--** |cff"..Nurfed_FormatRGB(unittype)..unit.."|r Dies";
		end
	end
	if (rank) then
		text = text.." "..rank;
	end
	if (honor) then
		text = text.." (+"..honor.." Honor)";
	end
	if (dishonor) then
		text = text.." (Dishonorable)";
	end
	if (xp) then
		if (text) then
			text = text.." You Gain "..xp.." Exp";
		else
			text = "You Gain "..xp.." Exp";
		end
	end
	if (xpbonus1) then
		text = text.." "..xpbonus1..")";
	end
	if (xpbonus2) then
		text = text.." "..xpbonus2..")";
	end
	Nurfed_CombatLogPrint(text);
end

local function  Nurfed_FormatGS(globalString)
	globalString = string.gsub(globalString, "%%s", "(.+)");
	globalString = string.gsub(globalString, "%%d", "(%%d+)");
	--Nurfed_CombatLogPrint(globalString);
	return globalString;
end

local function Nurfed_CombatLogParse(event, arg1)
	local unit, target, spell, damage, damagetype, xp, xpbonus1, xpbonus2, xpbonustype1, xpbonustype2, rank, honor;

	--Player Damage Events
	if (event == "CHAT_MSG_COMBAT_SELF_HITS") then
		for target, damage in string.gfind(arg1, Nurfed_FormatGS(COMBATHITCRITSELFOTHER)) do
			Nurfed_CombatLogDamage("melee_hit", YOU, target, damage, true);
			return;
		end
		for target, damage in string.gfind(arg1, Nurfed_FormatGS(COMBATHITSELFOTHER)) do
			Nurfed_CombatLogDamage("melee_hit", YOU, target, damage);
			return;
		end

		--Environmental
		for damage in string.gfind(arg1, Nurfed_FormatGS(VSENVIRONMENTALDAMAGE_FALLING_SELF)) do
			Nurfed_CombatLogDamage("env", YOU, nil, damage, nil, "Fall");
			return;
		end
		for damage in string.gfind(arg1, Nurfed_FormatGS(VSENVIRONMENTALDAMAGE_DROWNING_SELF)) do
			Nurfed_CombatLogDamage("env", YOU, nil, damage, nil, "Drown");
			return;
		end
		for damage in string.gfind(arg1, Nurfed_FormatGS(VSENVIRONMENTALDAMAGE_FATIGUE_SELF)) do
			Nurfed_CombatLogDamage("env", YOU, nil, damage, nil, "Fatigue");
			return;
		end
		for damage in string.gfind(arg1, Nurfed_FormatGS(VSENVIRONMENTALDAMAGE_FIRE_SELF)) do
			Nurfed_CombatLogDamage("env", YOU, nil, damage, nil, "Fire");
			return;
		end
		for damage in string.gfind(arg1, Nurfed_FormatGS(VSENVIRONMENTALDAMAGE_LAVA_SELF)) do
			Nurfed_CombatLogDamage("env", YOU, nil, damage, nil, "Lava");
			return;
		end
		for damage in string.gfind(arg1, Nurfed_FormatGS(VSENVIRONMENTALDAMAGE_SLIME_SELF)) do
			Nurfed_CombatLogDamage("env", YOU, nil, damage, nil, "Slime");
			return;
		end

	elseif (event == "CHAT_MSG_COMBAT_SELF_MISSES") then
		for target in string.gfind(arg1, Nurfed_FormatGS(MISSEDSELFOTHER)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Miss");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSABSORBSELFOTHER)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Absorb");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSBLOCKSELFOTHER)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Block");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSDEFLECTSELFOTHER)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Deflect");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSDODGESELFOTHER)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Dodge");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSEVADESELFOTHER)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Evade");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSIMMUNESELFOTHER)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Immune");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSPARRYSELFOTHER)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Parry");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSRESISTSELFOTHER)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Resist");
			return;
		end

	elseif (event == "CHAT_MSG_SPELL_SELF_DAMAGE") then
		for spell, target, damage, damagetype in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGCRITSCHOOLSELFOTHER)) do
			Nurfed_CombatLogDamage("spell_hit", YOU, target, damage, true, spell, damagetype);
			return;
		end
		for spell, target, damage, damagetype in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGSCHOOLSELFOTHER)) do
			Nurfed_CombatLogDamage("spell_hit", YOU, target, damage, nil, spell, damagetype);
			return;
		end
		for spell, target, damage in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGCRITSELFOTHER)) do
			Nurfed_CombatLogDamage("spell_hit", YOU, target, damage, true, spell);
			return;
		end
		for spell, target, damage in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGSELFOTHER)) do
			Nurfed_CombatLogDamage("spell_hit", YOU, target, damage, nil, spell);
			return;
		end
		for spell, target in string.gfind(arg1, Nurfed_FormatGS(SPELLRESISTSELFOTHER)) do
			Nurfed_CombatLogDamage("spell_miss", target, YOU, nil, nil, spell, nil, true);
			return;
		end

	--Damage Events on Player
	elseif (event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS") then
		for target, damage in string.gfind(arg1, Nurfed_FormatGS(COMBATHITCRITOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_hit", target, YOU, damage, true);
			return;
		end
		for target, damage in string.gfind(arg1, Nurfed_FormatGS(COMBATHITOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_hit", target, YOU, damage);
			return;
		end

	elseif (event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_MISSES") then
		for target in string.gfind(arg1, Nurfed_FormatGS(MISSEDOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", target, YOU, nil, nil, "Miss");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSABSORBOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target,nil, nil, "Absorb");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSBLOCKOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Block");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSDEFLECTOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Deflect");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSDODGEOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Dodge");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSEVADEOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Evade");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSIMMUNEOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Immune");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSPARRYOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Parry");
			return;
		end

	elseif (event == "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE") then
		for target, spell, damage, damagetype in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGCRITSCHOOLOTHERSELF)) do
			Nurfed_CombatLogDamage("spell_hit", target, YOU, damage, true, spell, damagetype);
			return;
		end
		for target, spell, damage, damagetype in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGSCHOOLOTHERSELF)) do
			Nurfed_CombatLogDamage("spell_hit", target, YOU, damage, nil, spell, damagetype);
			return;
		end
		for target, spell, damage in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGCRITOTHERSELF)) do
			Nurfed_CombatLogDamage("spell_hit", target, YOU, damage, true, spell);
			return;
		end
		for target, spell, damage in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGOTHERSELF)) do
			Nurfed_CombatLogDamage("spell_hit", target, YOU, damage, nil, spell);
			return;
		end
		for target, spell in string.gfind(arg1, Nurfed_FormatGS(SPELLRESISTOTHERSELF)) do
			Nurfed_CombatLogDamage("spell_miss", target, YOU, nil, nil, spell, nil, true);
			return;
		end

	-- Other Damage Events
	elseif (event ==	"CHAT_MSG_COMBAT_PARTY_HITS"
		or event ==	"CHAT_MSG_COMBAT_FRIENDLYPLAYER_HITS"
		or event ==	"CHAT_MSG_COMBAT_PET_HITS"
		or event ==	"CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS"
		or event ==	"CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS"
		or event ==	"CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS") then

		for target, damage in string.gfind(arg1, Nurfed_FormatGS(COMBATHITCRITOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_hit", target, YOU, damage, true);
			return;
		end
		for target, damage in string.gfind(arg1, Nurfed_FormatGS(COMBATHITOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_hit", target, YOU, damage);
			return;
		end

		for unit, target, damage in string.gfind(arg1, Nurfed_FormatGS(COMBATHITCRITOTHEROTHER)) do
			Nurfed_CombatLogDamage("melee_hit",unit, target, damage, true);
			return;
		end
		for unit, target, damage in string.gfind(arg1, Nurfed_FormatGS(COMBATHITOTHEROTHER)) do
			Nurfed_CombatLogDamage("melee_hit",unit, target, damage);
			return;
		end

		--Environmental
		for unit, damage in string.gfind(arg1, Nurfed_FormatGS(VSENVIRONMENTALDAMAGE_FALLING_OTHER)) do
			Nurfed_CombatLogDamage("env", unit, nil, damage, nil, "Fall");
			return;
		end
		for unit, damage in string.gfind(arg1, Nurfed_FormatGS(VSENVIRONMENTALDAMAGE_DROWNING_OTHER)) do
			Nurfed_CombatLogDamage("env", unit, nil, damage, nil, "Drown");
			return;
		end
		for unit, damage in string.gfind(arg1, Nurfed_FormatGS(VSENVIRONMENTALDAMAGE_FATIGUE_OTHER)) do
			Nurfed_CombatLogDamage("env", unit, nil, damage, nil, "Fatigue");
			return;
		end
		for unit, damage in string.gfind(arg1, Nurfed_FormatGS(VSENVIRONMENTALDAMAGE_FIRE_OTHER)) do
			Nurfed_CombatLogDamage("env", unit, nil, damage, nil, "Fire");
			return;
		end
		for unit, damage in string.gfind(arg1, Nurfed_FormatGS(VSENVIRONMENTALDAMAGE_LAVA_OTHER)) do
			Nurfed_CombatLogDamage("env", unit, nil, damage, nil, "Lava");
			return;
		end
		for unit, damage in string.gfind(arg1, Nurfed_FormatGS(VSENVIRONMENTALDAMAGE_SLIME_OTHER)) do
			Nurfed_CombatLogDamage("env", unit, nil, damage, nil, "Slime");
			return;
		end

	elseif (event ==	"CHAT_MSG_COMBAT_PARTY_MISSES"
		or event ==	"CHAT_MSG_COMBAT_FRIENDLYPLAYER_MISSES"
		or event ==	"CHAT_MSG_COMBAT_PET_MISSES"
		or event ==	"CHAT_MSG_COMBAT_HOSTILEPLAYER_MISSES"
		or event ==	"CHAT_MSG_COMBAT_CREATURE_VS_PARTY_MISSES"
		or event ==	"CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_MISSES") then

		for unit, target in string.gfind(arg1, Nurfed_FormatGS(MISSEDOTHEROTHER)) do
			Nurfed_CombatLogDamage("melee_miss",unit, target, nil, nil, "Miss");
			return;
		end
		for unit, target in string.gfind(arg1, Nurfed_FormatGS(VSABSORBOTHEROTHER)) do
			Nurfed_CombatLogDamage("melee_miss",unit, target, nil, nil, "Absorb");
			return;
		end
		for unit, target in string.gfind(arg1, Nurfed_FormatGS(VSBLOCKOTHEROTHER)) do
			Nurfed_CombatLogDamage("melee_miss",unit, target, nil, nil, "Block");
			return;
		end
		for unit, target in string.gfind(arg1, Nurfed_FormatGS(VSDEFLECTOTHEROTHER)) do
			Nurfed_CombatLogDamage("melee_miss",unit, target, nil, nil, "Deflect");
			return;
		end
		for unit, target in string.gfind(arg1, Nurfed_FormatGS(VSDODGEOTHEROTHER)) do
			Nurfed_CombatLogDamage("melee_miss",unit, target, nil, nil, "Dodge");
			return;
		end
		for unit, target in string.gfind(arg1, Nurfed_FormatGS(VSEVADEOTHEROTHER)) do
			Nurfed_CombatLogDamage("melee_miss",unit, target, nil, nil, "Evade");
			return;
		end
		for unit, target in string.gfind(arg1, Nurfed_FormatGS(VSIMMUNEOTHEROTHER)) do
			Nurfed_CombatLogDamage("melee_miss",unit, target, nil, nil, "Immune");
			return;
		end
		for unit, target in string.gfind(arg1, Nurfed_FormatGS(VSPARRYOTHEROTHER)) do
			Nurfed_CombatLogDamage("melee_miss",unit, target, nil, nil, "Parry");
			return;
		end
		for unit, target in string.gfind(arg1, Nurfed_FormatGS(VSRESISTOTHEROTHER)) do
			Nurfed_CombatLogDamage("spell_miss",unit, target, nil, nil, "Resist");
			return;
		end

		for target in string.gfind(arg1, Nurfed_FormatGS(MISSEDOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", target, YOU, nil, nil, "Miss");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSABSORBOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target,nil, nil, "Absorb");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSBLOCKOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Block");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSDEFLECTOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Deflect");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSDODGEOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Dodge");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSEVADEOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Evade");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSIMMUNEOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Immune");
			return;
		end
		for target in string.gfind(arg1, Nurfed_FormatGS(VSPARRYOTHERSELF)) do
			Nurfed_CombatLogDamage("melee_miss", YOU, target, nil, nil, "Parry");
			return;
		end
		for target, spell in string.gfind(arg1, Nurfed_FormatGS(SPELLRESISTOTHERSELF)) do
			Nurfed_CombatLogDamage("spell_miss", target, YOU, nil, nil, spell, nil, true);
			return;
		end

	elseif (event ==	"CHAT_MSG_SPELL_PARTY_DAMAGE"
		or event ==	"CHAT_MSG_SPELL_FRIENDLYPLAYER_DAMAGE"
		or event ==	"CHAT_MSG_SPELL_PET_DAMAGE"
		or event ==	"CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE"
		or event ==	"CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE"
		or event ==	"CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE") then

		--Spells
		for target, spell, damage, damagetype in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGCRITSCHOOLOTHERSELF)) do
			Nurfed_CombatLogDamage("spell_hit", target, YOU, damage, true, spell, damagetype);
			return;
		end
		for target, spell, damage, damagetype in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGSCHOOLOTHERSELF)) do
			Nurfed_CombatLogDamage("spell_hit", target, YOU, damage, nil, spell, damagetype);
			return;
		end
		for target, spell, damage in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGCRITOTHERSELF)) do
			Nurfed_CombatLogDamage("spell_hit", target, YOU, damage, true, spell);
			return;
		end
		for target, spell, damage in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGOTHERSELF)) do
			Nurfed_CombatLogDamage("spell_hit", target, YOU, damage, nil, spell);
			return;
		end
		for target, spell in string.gfind(arg1, Nurfed_FormatGS(SPELLRESISTOTHERSELF)) do
			Nurfed_CombatLogDamage("spell_miss", target, YOU, nil, nil, spell, nil, true);
			return;
		end

		for unit, spell, target, damage, damagetype in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGCRITSCHOOLOTHEROTHER)) do
			Nurfed_CombatLogDamage("spell_hit", unit, target, damage, true, spell, damagetype);
			return;
		end
		for unit, spell, target, damage, damagetype in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGSCHOOLOTHEROTHER)) do
			Nurfed_CombatLogDamage("spell_hit", unit, target, damage, nil, spell, damagetype);
			return;
		end
		for unit, spell, target, damage in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGCRITOTHEROTHER)) do
			Nurfed_CombatLogDamage("spell_hit", unit, target, damage, true, spell);
			return;
		end
		for unit, spell, target, damage in string.gfind(arg1, Nurfed_FormatGS(SPELLLOGOTHEROTHER)) do
			Nurfed_CombatLogDamage("spell_hit", unit, target, damage, nil, spell);
			return;
		end
		for unit, spell, target in string.gfind(arg1, Nurfed_FormatGS(SPELLRESISTOTHEROTHER)) do
			Nurfed_CombatLogDamage("spell_miss", target, unit, nil, nil, spell, nil, true);
			return;
		end

	--DOT Events
	elseif (event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE") then
		for damage, damagetype, target, spell in string.gfind(arg1, Nurfed_FormatGS(PERIODICAURADAMAGEOTHERSELF)) do
			Nurfed_CombatLogDamage("dot_hit", target, YOU, damage, nil, spell, damagetype);
			return;
		end
		for debuff in string.gfind(arg1, Nurfed_FormatGS(AURAADDEDSELFHARMFUL)) do
			Nurfed_AuraFormat("debuff", YOU, debuff, nil, true);
			return;
		end

	elseif (event ==	"CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE"
		or event ==	"CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE"
		or event ==	"CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE"
		or event ==	"CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE") then

		for target, damage, damagetype, unit, spell in string.gfind(arg1, Nurfed_FormatGS(PERIODICAURADAMAGEOTHEROTHER)) do
			Nurfed_CombatLogDamage("dot_hit", unit, target, damage, nil, spell, damagetype);
			return;
		end
		for target, damage, damagetype, spell in string.gfind(arg1, Nurfed_FormatGS(PERIODICAURADAMAGESELFOTHER)) do
			Nurfed_CombatLogDamage("dot_hit", YOU, target, damage, nil, spell, damagetype);
			return;
		end
		for target, debuff in string.gfind(arg1, Nurfed_FormatGS(AURAADDEDOTHERHARMFUL)) do
			Nurfed_AuraFormat("debuff", target, debuff, nil, true);
			return;
		end

	--Healing Events
	elseif (event == "CHAT_MSG_SPELL_SELF_BUFF") then
		for spell, damage in string.gfind(arg1, Nurfed_FormatGS(HEALEDCRITSELFSELF)) do
			Nurfed_CombatLogDamage("heal", YOU, YOU, damage, true, spell, "Heal");
			return;
		end
		for spell, damage in string.gfind(arg1, Nurfed_FormatGS(HEALEDSELFSELF)) do
			Nurfed_CombatLogDamage("heal", YOU, YOU, damage, nil, spell, "Heal");
			return;
		end
		for spell, target, damage in string.gfind(arg1, Nurfed_FormatGS(HEALEDCRITSELFOTHER)) do
			Nurfed_CombatLogDamage("heal", YOU, target, damage, true, spell, "Heal");
			return;
		end
		for spell, target, damage in string.gfind(arg1, Nurfed_FormatGS(HEALEDSELFOTHER)) do
			Nurfed_CombatLogDamage("heal", YOU, target, damage, nil, spell, "Heal");
			return;
		end

	elseif (event == "CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS") then
		for damage, target, spell in string.gfind(arg1, Nurfed_FormatGS(PERIODICAURAHEALOTHERSELF)) do
			Nurfed_CombatLogDamage("heal", target, YOU, damage, nil, spell, "Heal");
			return;
		end
		for damage, spell in string.gfind(arg1, Nurfed_FormatGS(PERIODICAURAHEALSELFSELF)) do
			Nurfed_CombatLogDamage("heal", YOU, YOU, damage, nil, spell, "Heal");
			return;
		end
		for buff in string.gfind(arg1, Nurfed_FormatGS(AURAADDEDSELFHELPFUL)) do
			Nurfed_AuraFormat("buff", YOU, buff);
			return;
		end

	elseif (event ==	"CHAT_MSG_SPELL_PARTY_BUFF"
		or event ==	"CHAT_MSG_SPELL_PET_BUFF"
		or event ==	"CHAT_MSG_SPELL_FRIENDLYPLAYER_BUFF"
		or event ==	"CHAT_MSG_SPELL_HOSTILEPLAYER_BUFF") then

		for unit, spell, target, damage in string.gfind(arg1, Nurfed_FormatGS(HEALEDCRITOTHEROTHER)) do
			Nurfed_CombatLogDamage("heal", unit, target, damage, true, spell, "Heal");
			return;
		end
		for unit, spell, target, damage in string.gfind(arg1, Nurfed_FormatGS(HEALEDOTHEROTHER)) do
			Nurfed_CombatLogDamage("heal", unit, target, damage, nil, spell, "Heal");
			return;
		end
		for target, spell, damage in string.gfind(arg1, Nurfed_FormatGS(HEALEDCRITOTHERSELF)) do
			Nurfed_CombatLogDamage("heal", target, YOU, damage, true, spell, "Heal");
			return;
		end
		for target, spell, damage in string.gfind(arg1, Nurfed_FormatGS(HEALEDOTHERSELF)) do
			Nurfed_CombatLogDamage("heal", target, YOU, damage, nil, spell, "Heal");
			return;
		end

	elseif (event ==	"CHAT_MSG_SPELL_PERIODIC_PARTY_BUFFS"
		or event ==	"CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_BUFFS"
		or event ==	"CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_BUFFS"
		or event ==	"CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS") then

		for target, damage, unit, spell in string.gfind(arg1, Nurfed_FormatGS(PERIODICAURAHEALOTHEROTHER)) do
			Nurfed_CombatLogDamage("heal", unit, target, damage, nil, spell, "Heal");
			return;
		end
		for target, damage, spell in string.gfind(arg1, Nurfed_FormatGS(PERIODICAURAHEALSELFOTHER)) do
			Nurfed_CombatLogDamage("heal", YOU, target, damage, nil, spell, "Heal");
			return;
		end
		for target, buff in string.gfind(arg1, Nurfed_FormatGS(AURAADDEDOTHERHELPFUL)) do
			Nurfed_AuraFormat("buff", target, buff);
			return;
		end

	--Aura Removed Events
	elseif (event ==	"CHAT_MSG_SPELL_BREAK_AURA"
		or event ==	"CHAT_MSG_SPELL_AURA_GONE_SELF"
		or event ==	"CHAT_MSG_SPELL_AURA_GONE_PARTY"
		or event ==	"CHAT_MSG_SPELL_AURA_GONE_OTHER") then
		
		for buff in string.gfind(arg1, Nurfed_FormatGS(AURADISPELSELF)) do
			Nurfed_AuraFormat("buff", YOU, buff, true);
			return;
		end
		for buff in string.gfind(arg1, Nurfed_FormatGS(AURAREMOVEDSELF)) do
			Nurfed_AuraFormat("buff", YOU, buff, true);
			return;
		end
		for target, buff in string.gfind(arg1, Nurfed_FormatGS(AURADISPELOTHER)) do
			Nurfed_AuraFormat("buff", target, buff, true);
			return;
		end
		for buff, target in string.gfind(arg1, Nurfed_FormatGS(AURAREMOVEDOTHER)) do
			Nurfed_AuraFormat("buff", target, buff, true);
			return;
		end

	--Death Messages
	elseif (event ==	"CHAT_MSG_COMBAT_XP_GAIN"
		or event ==	"CHAT_MSG_COMBAT_HONOR_GAIN"
		or event ==	"CHAT_MSG_COMBAT_FRIENDLY_DEATH"
		or event ==	"CHAT_MSG_COMBAT_HOSTILE_DEATH") then
		for unit, honor in string.gfind(arg1, Nurfed_FormatGS(COMBATLOG_HONORGAIN)) do
			Nurfed_DeathFormat("death_honor", unit, nil, honor);
			return;
		end
		for unit, xp, xpbonus1, xpbonustype1 in string.gfind(arg1, Nurfed_FormatGS(COMBATLOG_XPGAIN_EXHAUSTION1)) do
			Nurfed_DeathFormat("death_xp", unit, nil, nil, nil, xp, xpbonus1);
			return;
		end
		for unit, xp, xpbonus1, xpbonustype1, xpbonus2 in string.gfind(arg1, Nurfed_FormatGS(COMBATLOG_XPGAIN_EXHAUSTION1_GROUP)) do
			Nurfed_DeathFormat("death_xp", unit, nil, nil, nil, xp, xpbonus1, xpbonus2);
			return;
		end
		for unit, xp, xpbonus1, xpbonustype1, xpbonus2 in string.gfind(arg1, Nurfed_FormatGS(COMBATLOG_XPGAIN_EXHAUSTION1_RAID)) do
			Nurfed_DeathFormat("death_xp", unit, nil, nil, nil, xp, xpbonus1, xpbonus2);
			return;
		end
		for unit, xp, xpbonus1 in string.gfind(arg1, Nurfed_FormatGS(COMBATLOG_XPGAIN_FIRSTPERSON_GROUP)) do
			Nurfed_DeathFormat("death_xp", unit, nil, nil, nil, xp, xpbonus1);
			return;
		end
		for unit, xp, xpbonus1 in string.gfind(arg1, Nurfed_FormatGS(COMBATLOG_XPGAIN_FIRSTPERSON_RAID)) do
			Nurfed_DeathFormat("death_xp", unit, nil, nil, nil, xp, xpbonus1);
			return;
		end
		for unit, xp in string.gfind(arg1, Nurfed_FormatGS(COMBATLOG_XPGAIN_FIRSTPERSON)) do
			Nurfed_DeathFormat("death_xp", unit, nil, nil, nil, xp);
			return;
		end
		for xp in string.gfind(arg1, Nurfed_FormatGS(COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED)) do
			Nurfed_DeathFormat("death_xp", nil, nil, nil, nil, xp);
			return;
		end
		for xp in string.gfind(arg1, Nurfed_FormatGS(ERR_QUEST_REWARD_EXP_I)) do
			Nurfed_DeathFormat("death_xp", nil, nil, nil, nil, xp);
			return;
		end
		for unit in string.gfind(arg1, Nurfed_FormatGS(COMBATLOG_DISHONORGAIN)) do
			Nurfed_DeathFormat("death_dishonor", unit, nil, nil, true);
			return;
		end
		for unit in string.gfind(arg1, Nurfed_FormatGS(UNITDIESOTHER)) do
			Nurfed_DeathFormat("death", unit);
			return;
		end
		if (arg1 == UNITDIESSELF) then
			Nurfed_DeathFormat("death", YOU);
			return;
		end

	-- Casting Events
	elseif (event ==	"CHAT_MSG_SPELL_CREATURE_VS_SELF_BUFF"
		or event ==	"CHAT_MSG_SPELL_CREATURE_VS_PARTY_BUFF"
		or event ==	"CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF") then

	--Damage Shield Events
	elseif (event ==	"CHAT_MSG_SPELL_DAMAGESHIELDS_ON_SELF"
		or event ==	"CHAT_MSG_SPELL_DAMAGESHIELDS_ON_OTHERS") then
	end
end

function Nurfed_CombatLogOnEvent(event)
	if (event == "VARIABLES_LOADED") then
		if( not Nurfed_CombatLogConfig or not Nurfed_CombatLogConfig.Version) then
			Nurfed_CombatLogConfig = {};
		end
		Nurfed_CombatLogConfig.Version = "10.22.2005";

		--Spell
		if ( not Nurfed_CombatLogConfig.Fire) then
			Nurfed_CombatLogConfig.Fire = { r = (255/255), g = (0/255), b = (0/255) };
		end
		if ( not Nurfed_CombatLogConfig.Frost) then
			Nurfed_CombatLogConfig.Frost = { r = (0/255), g = (102/255), b = (255/255) };
		end
		if ( not Nurfed_CombatLogConfig.Shadow) then
			Nurfed_CombatLogConfig.Shadow = { r = (202/255), g = (76/255), b = (217/255) };
		end
		if ( not Nurfed_CombatLogConfig.Arcane) then
			Nurfed_CombatLogConfig.Arcane = { r = (153/255), g = (204/255), b = (255/255) };
		end
		if ( not Nurfed_CombatLogConfig.Nature) then
			Nurfed_CombatLogConfig.Nature = { r = (0/255), g = (102/255), b = (0/255) };
		end
		if ( not Nurfed_CombatLogConfig.Holy) then
			Nurfed_CombatLogConfig.Holy = { r = (255/255), g = (255/255), b = (0/255) };
		end
		if ( not Nurfed_CombatLogConfig.Heal) then
			Nurfed_CombatLogConfig.Heal = { r = (96/255), g = (255/255), b = (99/255) };
		end
		if ( not Nurfed_CombatLogConfig.Generic) then
			Nurfed_CombatLogConfig.Generic = { r = (255/255), g = (255/255), b = (150/255) };
		end

		--Unit
		if ( not Nurfed_CombatLogConfig.You) then
			Nurfed_CombatLogConfig.You = { r = (0/255), g = (192/255), b = (255/255) };
		end
		if ( not Nurfed_CombatLogConfig.Pet) then
			Nurfed_CombatLogConfig.Pet = { r = (0/255), g = (153/255), b = (102/255) };
		end
		if ( not Nurfed_CombatLogConfig.Party) then
			Nurfed_CombatLogConfig.Party = { r = (255/255), g = (153/255), b = (0/255) };
		end
		if ( not Nurfed_CombatLogConfig.Raid) then
			Nurfed_CombatLogConfig.Raid = { r = (251/255), g = (210/255), b = (132/255) };
		end
		if ( not Nurfed_CombatLogConfig.Enemy) then
			Nurfed_CombatLogConfig.Enemy = { r = (255/255), g = (116/255), b = (109/255) };
		end

		--Other
		if ( not Nurfed_CombatLogConfig.Damage) then
			Nurfed_CombatLogConfig.Damage = { r = (255/255), g = (47/255), b = (47/255) };
		end
		if ( not Nurfed_CombatLogConfig.Overlay) then
			Nurfed_CombatLogConfig.Overlay = { r = (255/255), g = (255/255),  b = (0/255) };
		end
		if ( not Nurfed_CombatLogConfig.Aura) then
			Nurfed_CombatLogConfig.Aura = { r = (255/255), g = (255/255), b = (0/255) };
		end

		--Self
		if ( not Nurfed_CombatLogConfig.You_melee_hit) then
			Nurfed_CombatLogConfig.You_melee_hit = 1;
		end
		if ( not Nurfed_CombatLogConfig.You_melee_miss) then
			Nurfed_CombatLogConfig.You_melee_miss = 1;
		end
		if ( not Nurfed_CombatLogConfig.You_spell_hit) then
			Nurfed_CombatLogConfig.You_spell_hit = 1;
		end
		if ( not Nurfed_CombatLogConfig.You_spell_miss) then
			Nurfed_CombatLogConfig.You_spell_miss = 1;
		end
		if ( not Nurfed_CombatLogConfig.You_dot_hit) then
			Nurfed_CombatLogConfig.You_dot_hit = 1;
		end
		if ( not Nurfed_CombatLogConfig.You_heal) then
			Nurfed_CombatLogConfig.You_heal = 1;
		end
		if ( not Nurfed_CombatLogConfig.You_env) then
			Nurfed_CombatLogConfig.You_env = 1;
		end
		if ( not Nurfed_CombatLogConfig.You_buff) then
			Nurfed_CombatLogConfig.You_buff = 1;
		end
		if ( not Nurfed_CombatLogConfig.You_debuff) then
			Nurfed_CombatLogConfig.You_debuff = 1;
		end

		--Party
		if ( not Nurfed_CombatLogConfig.Party_melee_hit) then
			Nurfed_CombatLogConfig.Party_melee_hit = 1;
		end
		if ( not Nurfed_CombatLogConfig.Party_melee_miss) then
			Nurfed_CombatLogConfig.Party_melee_miss = 1;
		end
		if ( not Nurfed_CombatLogConfig.Party_spell_hit) then
			Nurfed_CombatLogConfig.Party_spell_hit = 1;
		end
		if ( not Nurfed_CombatLogConfig.Party_spell_miss) then
			Nurfed_CombatLogConfig.Party_spell_miss = 1;
		end
		if ( not Nurfed_CombatLogConfig.Party_dot_hit) then
			Nurfed_CombatLogConfig.Party_dot_hit = 1;
		end
		if ( not Nurfed_CombatLogConfig.Party_heal) then
			Nurfed_CombatLogConfig.Party_heal = 1;
		end
		if ( not Nurfed_CombatLogConfig.Party_env) then
			Nurfed_CombatLogConfig.Party_env = 1;
		end
		if ( not Nurfed_CombatLogConfig.Party_buff) then
			Nurfed_CombatLogConfig.Party_buff = 1;
		end
		if ( not Nurfed_CombatLogConfig.Party_debuff) then
			Nurfed_CombatLogConfig.Party_debuff = 1;
		end

		--Pet
		if ( not Nurfed_CombatLogConfig.Pet_melee_hit) then
			Nurfed_CombatLogConfig.Pet_melee_hit = 1;
		end
		if ( not Nurfed_CombatLogConfig.Pet_melee_miss) then
			Nurfed_CombatLogConfig.Pet_melee_miss = 1;
		end
		if ( not Nurfed_CombatLogConfig.Pet_spell_hit) then
			Nurfed_CombatLogConfig.Pet_spell_hit = 1;
		end
		if ( not Nurfed_CombatLogConfig.Pet_spell_miss) then
			Nurfed_CombatLogConfig.Pet_spell_miss = 1;
		end
		if ( not Nurfed_CombatLogConfig.Pet_dot_hit) then
			Nurfed_CombatLogConfig.Pet_dot_hit = 1;
		end
		if ( not Nurfed_CombatLogConfig.Pet_heal) then
			Nurfed_CombatLogConfig.Pet_heal = 1;
		end
		if ( not Nurfed_CombatLogConfig.Pet_env) then
			Nurfed_CombatLogConfig.Pet_env = 1;
		end
		if ( not Nurfed_CombatLogConfig.Pet_buff) then
			Nurfed_CombatLogConfig.Pet_buff = 1;
		end
		if ( not Nurfed_CombatLogConfig.Pet_debuff) then
			Nurfed_CombatLogConfig.Pet_debuff = 1;
		end

		--Raid
		if ( not Nurfed_CombatLogConfig.Raid_melee_hit) then
			Nurfed_CombatLogConfig.Raid_melee_hit = 1;
		end
		if ( not Nurfed_CombatLogConfig.Raid_melee_miss) then
			Nurfed_CombatLogConfig.Raid_melee_miss = 1;
		end
		if ( not Nurfed_CombatLogConfig.Raid_spell_hit) then
			Nurfed_CombatLogConfig.Raid_spell_hit = 1;
		end
		if ( not Nurfed_CombatLogConfig.Raid_spell_miss) then
			Nurfed_CombatLogConfig.Raid_spell_miss = 1;
		end
		if ( not Nurfed_CombatLogConfig.Raid_dot_hit) then
			Nurfed_CombatLogConfig.Raid_dot_hit = 1;
		end
		if ( not Nurfed_CombatLogConfig.Raid_heal) then
			Nurfed_CombatLogConfig.Raid_heal = 1;
		end
		if ( not Nurfed_CombatLogConfig.Raid_env) then
			Nurfed_CombatLogConfig.Raid_env = 1;
		end
		if ( not Nurfed_CombatLogConfig.Raid_buff) then
			Nurfed_CombatLogConfig.Raid_buff = 1;
		end
		if ( not Nurfed_CombatLogConfig.Raid_debuff) then
			Nurfed_CombatLogConfig.Raid_debuff = 1;
		end

		--Enemy
		if ( not Nurfed_CombatLogConfig.Enemy_melee_hit_You) then
			Nurfed_CombatLogConfig.Enemy_melee_hit_You = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_melee_hit_Party) then
			Nurfed_CombatLogConfig.Enemy_melee_hit_Party = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_melee_hit_Raid) then
			Nurfed_CombatLogConfig.Enemy_melee_hit_Raid = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_melee_hit_Pet) then
			Nurfed_CombatLogConfig.Enemy_melee_hit_Pet = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_melee_hit_Enemy) then
			Nurfed_CombatLogConfig.Enemy_melee_hit_Enemy = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_melee_miss_You) then
			Nurfed_CombatLogConfig.Enemy_melee_miss_You = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_melee_miss_Party) then
			Nurfed_CombatLogConfig.Enemy_melee_miss_Party = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_melee_miss_Raid) then
			Nurfed_CombatLogConfig.Enemy_melee_miss_Raid = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_melee_miss_Pet) then
			Nurfed_CombatLogConfig.Enemy_melee_miss_Pet = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_melee_miss_Enemy) then
			Nurfed_CombatLogConfig.Enemy_melee_miss_Enemy = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_spell_hit_You) then
			Nurfed_CombatLogConfig.Enemy_spell_hit_You = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_spell_hit_Party) then
			Nurfed_CombatLogConfig.Enemy_spell_hit_Party = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_spell_hit_Raid) then
			Nurfed_CombatLogConfig.Enemy_spell_hit_Raid = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_spell_hit_Pet) then
			Nurfed_CombatLogConfig.Enemy_spell_hit_Pet = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_spell_hit_Enemy) then
			Nurfed_CombatLogConfig.Enemy_spell_hit_Enemy = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_spell_miss_You) then
			Nurfed_CombatLogConfig.Enemy_spell_miss_You = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_spell_miss_Party) then
			Nurfed_CombatLogConfig.Enemy_spell_miss_Party = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_spell_miss_Raid) then
			Nurfed_CombatLogConfig.Enemy_spell_miss_Raid = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_spell_miss_Pet) then
			Nurfed_CombatLogConfig.Enemy_spell_miss_Pet = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_spell_miss_Enemy) then
			Nurfed_CombatLogConfig.Enemy_spell_miss_Enemy = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_dot_hit_You) then
			Nurfed_CombatLogConfig.Enemy_dot_hit_You = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_dot_hit_Party) then
			Nurfed_CombatLogConfig.Enemy_dot_hit_Party = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_dot_hit_Raid) then
			Nurfed_CombatLogConfig.Enemy_dot_hit_Raid = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_dot_hit_Pet) then
			Nurfed_CombatLogConfig.Enemy_dot_hit_Pet = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_dot_hit_Enemy) then
			Nurfed_CombatLogConfig.Enemy_dot_hit_Enemy = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_heal_You) then
			Nurfed_CombatLogConfig.Enemy_heal_You = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_heal_Party) then
			Nurfed_CombatLogConfig.Enemy_heal_Party = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_heal_Raid) then
			Nurfed_CombatLogConfig.Enemy_heal_Raid = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_heal_Pet) then
			Nurfed_CombatLogConfig.Enemy_heal_Pet = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_heal_Enemy) then
			Nurfed_CombatLogConfig.Enemy_heal_Enemy = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_env) then
			Nurfed_CombatLogConfig.Enemy_env = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_buff) then
			Nurfed_CombatLogConfig.Enemy_buff = 1;
		end
		if ( not Nurfed_CombatLogConfig.Enemy_debuff) then
			Nurfed_CombatLogConfig.Enemy_debuff = 1;
		end

	elseif (event == "PLAYER_ENTERING_WORLD") then
		ChatFrame_RemoveAllMessageGroups(ChatFrame2);
	else
		--Nurfed_CombatLogPrint(event.." - "..arg1);
		Nurfed_CombatLogParse(event, arg1);
	end
end

local Nurfed_CombatOptionTabs = {
	[1] = GENERAL,
	[2] = YOU,
	[3] = PARTY,
	[4] = PET,
	[5] = RAID,
	[6] = FACTION_OTHER.." 1",
	[7] = FACTION_OTHER.." 2",
};

local Nurfed_CombatCheckBoxes = {
	--You
	[1] = { text = "Your Melee Hits", option = "You_melee_hit" },
	[2] = { text = "Your Melee Misses", option = "You_melee_miss" },
	[3] = { text = "Your Spell Hits", option = "You_spell_hit" },
	[4] = { text = "Your Spell Resists", option = "You_spell_miss" },
	[5] = { text = "Your DOT's", option = "You_dot_hit" },
	[6] = { text = "Your Heals", option = "You_heal", align = "right" },
	[7] = { text = "Your Environment Damage", option = "You_env", align = "right" },
	[8] = { text = "Your Buffs", option = "You_buff", align = "right" },
	[9] = { text = "Your DeBuffs", option = "You_debuff", align = "right" },
	
	--Party
	[10] = { text = "Party Melee Hits", option = "Party_melee_hit" },
	[11] = { text = "Party Melee Misses", option = "Party_melee_miss" },
	[12] = { text = "Party Spell Hits", option = "Party_spell_hit" },
	[13] = { text = "Party Spell Resists", option = "Party_spell_miss" },
	[14] = { text = "Party DOT's", option = "Party_dot_hit" },
	[15] = { text = "Party Heals", option = "Party_heal", align = "right" },
	[16] = { text = "Party Environment Damage", option = "Party_env", align = "right" },
	[17] = { text = "Party Buffs", option = "Party_buff", align = "right" },
	[18] = { text = "Party DeBuffs", option = "Party_debuff", align = "right" },
	
	--Pet
	[19] = { text = "Pet Melee Hits", option = "Pet_melee_hit" },
	[20] = { text = "Pet Melee Misses", option = "Pet_melee_miss" },
	[21] = { text = "Pet Spell Hits", option = "Pet_spell_hit" },
	[22] = { text = "Pet Spell Resists", option = "Pet_spell_miss" },
	[23] = { text = "Pet DOT's", option = "Pet_dot_hit" },
	[24] = { text = "Pet Heals", option = "Pet_heal", align = "right" },
	[25] = { text = "Pet Environment Damage", option = "Pet_env", align = "right" },
	[26] = { text = "Pet Buffs", option = "Pet_buff", align = "right" },
	[27] = { text = "Pet DeBuffs", option = "Pet_debuff", align = "right" },
	
	--Raid
	[28] = { text = "Raid Melee Hits", option = "Raid_melee_hit" },
	[29] = { text = "Raid Melee Misses", option = "Raid_melee_miss" },
	[30] = { text = "Raid Spell Hits", option = "Raid_spell_hit" },
	[31] = { text = "Raid Spell Resists", option = "Raid_spell_miss" },
	[32] = { text = "Raid DOT's", option = "Raid_dot_hit" },
	[33] = { text = "Raid Heals", option = "Raid_heal", align = "right" },
	[34] = { text = "Raid Environment Damage", option = "Raid_env", align = "right" },
	[35] = { text = "Raid Buffs", option = "Raid_buff", align = "right" },
	[36] = { text = "Raid DeBuffs", option = "Raid_debuff", align = "right" },
	
	--Other
	[37] = { text = "Other Melee Hits You", option = "Enemy_melee_hit_You" },
	[38] = { text = "Other Melee Hits Party", option = "Enemy_melee_hit_Party" },
	[39] = { text = "Other Melee Hits Raid", option = "Enemy_melee_hit_Raid" },
	[40] = { text = "Other Melee Hits Pet", option = "Enemy_melee_hit_Pet" },
	[41] = { text = "Other Melee Hits Other", option = "Enemy_melee_hit_Enemy" },

	[42] = { text = "Other Melee Misses You", option = "Enemy_melee_miss_You" },
	[43] = { text = "Other Melee Misses Party", option = "Enemy_melee_miss_Party" },
	[44] = { text = "Other Melee Misses Raid", option = "Enemy_melee_miss_Raid" },
	[45] = { text = "Other Melee Misses Pet", option = "Enemy_melee_miss_Pet", align = "right" },
	[46] = { text = "Other Melee Misses Other", option = "Enemy_melee_miss_Enemy", align = "right" },

	[47] = { text = "Other Spell Hits You", option = "Enemy_spell_hit_You", align = "right" },
	[48] = { text = "Other Spell Hits Party", option = "Enemy_spell_hit_Party", align = "right" },
	[49] = { text = "Other Spell Hits Raid", option = "Enemy_spell_hit_Raid" , align = "right"},
	[50] = { text = "Other Spell Hits Pet", option = "Enemy_spell_hit_Pet", align = "right" },
	[51] = { text = "Other Spell Hits Other", option = "Enemy_spell_hit_Enemy", align = "right" },

	[52] = { text = "Other Spell Resists You", option = "Enemy_spell_miss_You", align = "right" },
	[53] = { text = "Other Spell Resists Party", option = "Enemy_spell_miss_Party" },
	[54] = { text = "Other Spell Resists Raid", option = "Enemy_spell_miss_Raid" },
	[55] = { text = "Other Spell Resists Pet", option = "Enemy_spell_miss_Pet" },
	[56] = { text = "Other Spell Resists Other", option = "Enemy_spell_miss_Enemy" },

	[57] = { text = "Other DOT's You", option = "Enemy_dot_hit_You" },
	[58] = { text = "Other DOT's Party", option = "Enemy_dot_hit_Party" },
	[59] = { text = "Other DOT's Raid", option = "Enemy_dot_hit_Raid" },
	[60] = { text = "Other DOT's Pet", option = "Enemy_dot_hit_Pet" },
	[61] = { text = "Other DOT's Other", option = "Enemy_dot_hit_Enemy", align = "right" },

	[62] = { text = "Other Heals You", option = "Enemy_heal_You", align = "right" },
	[63] = { text = "Other Heals Party", option = "Enemy_heal_Party", align = "right" },
	[64] = { text = "Other Heals Raid", option = "Enemy_heal_Raid", align = "right" },
	[65] = { text = "Other Heals Pet", option = "Enemy_heal_Pet", align = "right" },
	[66] = { text = "Other Heals Other", option = "Enemy_heal_Enemy", align = "right" },

	[67] = { text = "Other Environment Damage", option = "Enemy_env", align = "right" },
	[68] = { text = "Other Buffs", option = "Enemy_buff", align = "right" },
	[69] = { text = "Other DeBuffs", option = "Enemy_debuff", align = "right" },
};

local Nurfed_CombatColorSwatches = {
	[1] = { text = "Fire Damage", option = "Fire" },
	[2] = { text = "Frost Damage", option = "Frost" },
	[3] = { text = "Shadow Damage", option = "Shadow" },
	[4] = { text = "Arcane Damage", option = "Arcane" },
	[5] = { text = "Nature Damage", option = "Nature" },
	[6] = { text = "Holy Damage", option = "Holy" },
	[7] = { text = "Heals", option = "Heal" },
	[8] = { text = "Generic Spell Damage", option = "Generic" },
	[9] = { text = "You", option = "You", align = "left" },
	[10] = { text = "Pet", option = "Pet", align = "left" },
	[11] = { text = "Party", option = "Party", align = "left" },
	[12] = { text = "Raid", option = "Raid", align = "left" },
	[13] = { text = "Enemy", option = "Enemy", align = "left" },
	[14] = { text = "Damage", option = "Damage", align = "left" },
	[15] = { text = "Crit Overlay", option = "Overlay", align = "left" },
	[16] = { text = "Auras", option = "Aura", align = "left" },
};

---------------------------------------------------------------------------
--			Nurfed Combat CheckBox Functions
---------------------------------------------------------------------------

function Nurfed_CombatCheckBoxOnShow()
	local id = this:GetID();
	local option = Nurfed_CombatCheckBoxes[id].option;
	local value = Nurfed_CombatLogConfig[option];
	local align = Nurfed_CombatCheckBoxes[id].align;
	if (align == "right") then
		getglobal("Nurfed_CombatOptionCheck"..id.."Text"):ClearAllPoints();
		getglobal("Nurfed_CombatOptionCheck"..id.."Text"):SetPoint("RIGHT", "Nurfed_CombatOptionCheck"..id, "LEFT", 0, 0);
	end
	getglobal("Nurfed_CombatOptionCheck"..id.."Text"):SetText(Nurfed_CombatCheckBoxes[id].text);
	this:SetChecked(value);
end

function Nurfed_CombatCheckBoxOnClick()
	local id = this:GetID();
	local func = Nurfed_CombatCheckBoxes[id].func;
	local arg = Nurfed_CombatCheckBoxes[id].arg;
	local value = Nurfed_CombatCheckBoxes[id].value;
	local option = Nurfed_CombatCheckBoxes[id].option;
	if (Nurfed_CombatLogConfig[option] == 1) then
		Nurfed_CombatLogConfig[option] = 0;
		PlaySound("igMainMenuOptionCheckBoxOff");
	else
		Nurfed_CombatLogConfig[option] = 1;
		PlaySound("igMainMenuOptionCheckBoxOn");
	end
	if (func) then
		if (arg) then
			func(arg);
		else
			func();
		end
	end
end

---------------------------------------------------------------------------
--			Nurfed Unit Color Swatch Functions
---------------------------------------------------------------------------

local function Nurfed_CombatSetColor(key, option)
	local r,g,b = ColorPickerFrame:GetColorRGB();
	local swatch,frame;
	swatch = getglobal("Nurfed_CombatColor"..key.."NormalTexture");
	frame = getglobal("Nurfed_CombatColor"..key);
	swatch:SetVertexColor(r,g,b);
	frame.r = r;
	frame.g = g;
	frame.b = b;
	Nurfed_CombatLogConfig[option].r = r;
	Nurfed_CombatLogConfig[option].g = g;
	Nurfed_CombatLogConfig[option].b = b;
end

local function Nurfed_CombatCancelColor(key, prev, option)
	local r = prev.r;
	local g = prev.g;
	local b = prev.b;
	local swatch, frame;
	swatch = getglobal("Nurfed_CombatColor"..key.."NormalTexture");
	button = getglobal("Nurfed_CombatColor"..key)
	swatch:SetVertexColor(r, g, b);
	button.r = r;
	button.g = g;
	button.b = b;
	Nurfed_CombatLogConfig[option].r = r;
	Nurfed_CombatLogConfig[option].g = g;
	Nurfed_CombatLogConfig[option].b = b;
end

function Nurfed_CombatColorSwatchOnShow()
	local id = this:GetID();
	local option = Nurfed_CombatColorSwatches[id].option;
	local border = Nurfed_CombatColorSwatches[id].border;
	local info = {};
	info = Nurfed_CombatLogConfig[option];
	local button,swatch;
	button = getglobal("Nurfed_CombatColor"..id);
	swatch = getglobal("Nurfed_CombatColor"..id.."NormalTexture");
	local align = Nurfed_CombatColorSwatches[id].align;
	if (align == "left") then
		getglobal("Nurfed_CombatColor"..id.."Text"):ClearAllPoints();
		getglobal("Nurfed_CombatColor"..id.."Text"):SetPoint("LEFT", "Nurfed_CombatColor"..id, "RIGHT", 0, 0);
	end

	button.r = info.r;
	button.g = info.g;
	button.b = info.b;
	button.swatchFunc = function() Nurfed_CombatSetColor(id, option) end;
	button.cancelFunc = function(x) Nurfed_CombatCancelColor(id, x, option) end;
	swatch:SetVertexColor(info.r, info.g, info.b);
	getglobal("Nurfed_CombatColor"..id.."Text"):SetText(Nurfed_CombatColorSwatches[id].text);
end

function Nurfed_CombatOpenColorPicker()
	CloseMenus();
	ColorPickerFrame.func = this.swatchFunc;
	ColorPickerFrame:SetColorRGB(this.r, this.g, this.b);
	ColorPickerFrame.previousValues = {r = this.r, g = this.g, b = this.b};
	ColorPickerFrame.cancelFunc = this.cancelFunc;
	ColorPickerFrame:Show();
end

---------------------------------------------------------------------------
--			Nurfed Combat Tab Functions
---------------------------------------------------------------------------

function Nurfed_CombatOptionTabsInit()
	for k,v in Nurfed_CombatOptionTabs do
		getglobal("Nurfed_CombatOptionTab"..k):SetText(v);
		getglobal("Nurfed_CombatOptionPage"..k.."SubFrame1Title"):SetText(v);
	end
	if ( not this.selectedTab ) then
		this.selectedTab = 1;
	end
	Nurfed_CombatOptionTabSelect(this.selectedTab);
end

function Nurfed_CombatOptionTabSelect(page)
	for k,v in Nurfed_CombatOptionTabs do
		if (page == k) then
			Nurfed_CombatOptionsFrame.selectedTab = k;
			getglobal("Nurfed_CombatOptionPage"..k):Show();
			getglobal("Nurfed_CombatOptionTab"..k):Disable();
		else
			getglobal("Nurfed_CombatOptionPage"..k):Hide();
			getglobal("Nurfed_CombatOptionTab"..k):Enable();
		end
	end
end

function NurfedCombat_SlashCommandHandler(msg)
	if( msg ) then
		Nurfed_CombatFramesMenu();
	end
end
